--- /usr/lib/portage/pym/portage.py.old	2006-01-03 21:30:39.815813216 -0600
+++ /usr/lib/portage/pym/portage.py	2006-01-03 22:46:14.164487440 -0600
@@ -1307,6 +1307,35 @@
 		self.configdict["pkg"]["USE"]    = self.puse[:] # this gets appended to USE
 		self.reset(keeping_pkg=1,use_cache=use_cache)
 
+	def setfeature(self,mycp,use_cache=1):
+		try:
+		    f = open("/etc/portage/package.features")
+		except:
+		    return
+		for line in f:
+		    if mycp in line.split(' ')[0]:
+			for each in line.split(' ')[1:len(line)]:
+			    localFeature = each.strip('\n')
+			    if localFeature.startswith("-"):
+				try:
+				    settings.features.remove(localFeature.strip("-"))
+				except ValueError:
+				    pass
+			    else:
+				if localFeature not in settings.features:
+				    settings.features.append(localFeature)
+		settings.features.sort()
+		print settings.features
+		featlist = " ".join(settings.features)
+		print featlist
+		settings.unlock()
+		settings.modifying()
+		settings['FEATURES'] = featlist 
+		settings.backup_changes("FEATURES")
+		settings.lock()
+		#self.reset(keeping_pkg=1,use_cache=use_cache)
+		f.close()
+
 	def setinst(self,mycpv,mydbapi):
 		# Grab the virtuals this package provides and add them into the tree virtuals.
 		provides = mydbapi.aux_get(mycpv, ["PROVIDE"])[0]
@@ -2378,6 +2407,7 @@
 		# XXX: We're doing a little hack here to curtain the gvisible locking
 		# XXX: that creates a deadlock... Really need to isolate that.
 		mysettings.reset(use_cache=use_cache)
+		mysettings.setfeature(getCPFromCPV(mycpv),use_cache=use_cache)
 	mysettings.setcpv(mycpv,use_cache=use_cache)
 
 	validcommands = ["help","clean","prerm","postrm","preinst","postinst",
